/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.ergebnis;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.ergebnis.boundary.AbstractDHondtQuotientListenImGebietSearchParameters;
import de.ivu.elect.business.ergebnis.boundary.DHondtQuotientListenImGebietChangeEvent;
import de.ivu.elect.business.ergebnis.boundary.DHondtQuotientListenImGebietConversationStore;
import de.ivu.elect.business.ergebnis.boundary.DHondtQuotientListenImGebietExtendedDAO;
import de.ivu.elect.business.ergebnis.boundary.DHondtQuotientListenImGebietSearch;
import de.ivu.elect.business.ergebnis.boundary.DHondtQuotientListenImGebietSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.ergebnis.entity.DHondtQuotientListenImGebiet;
import de.ivu.elect.business.ergebnis.entity.DHondtQuotientListenImGebietMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractDHondtQuotientListenImGebietSearchView.COMPONENT_NAME)
@View(viewId = AbstractDHondtQuotientListenImGebietSearchView.VIEW_ID, useCase = UseCasePermission.D_H_QU_LISTEN_IM_GEBIET_SEARCH)
public abstract class AbstractDHondtQuotientListenImGebietSearchView extends AbstractElectSearchView<DHondtQuotientListenImGebiet> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "dHondtQuotientListenImGebietSearchView";
  
  public static final String VIEW_ID = "/ergebnis/d-hondt-quotient-listen-im-gebiet-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractDHondtQuotientListenImGebietSearchView requestHandler;

  @Inject
  private transient DHondtQuotientListenImGebietExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(DHondtQuotientListenImGebietConversationStore.class)
  protected transient DHondtQuotientListenImGebietConversationStore conversationStore;

  @Inject
  protected transient DHondtQuotientListenImGebietSearch search;

  @Inject
  @ConversationGroup(AbstractDHondtQuotientListenImGebietSearchParameters.class)
  protected transient DHondtQuotientListenImGebietSearchParameters searchParameters;

  @Inject
  protected transient DHondtQuotientListenImGebietMeta entityMeta;

  public AbstractDHondtQuotientListenImGebietSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public DHondtQuotientListenImGebiet getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(DHondtQuotientListenImGebiet entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public DHondtQuotientListenImGebietSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<DHondtQuotientListenImGebiet> getEagerLoadingCollector() {
    return EagerLoadingCollector.<DHondtQuotientListenImGebiet> create();
  }

  @Override
  public List<DHondtQuotientListenImGebiet> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<DHondtQuotientListenImGebiet> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onDHondtQuotientListenImGebietChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) DHondtQuotientListenImGebietChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractDHondtQuotientListenImGebietSearchView {

    @View
    @Inject
    private transient Instance<AbstractDHondtQuotientListenImGebietSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractDHondtQuotientListenImGebietSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
